class Trig
{   
	ghost var Repr: set<object>;
    var sinCache : array<int>;
	var acosCache : array<int>;

	function IsValid() : bool
	reads this;
	{
	   this in Repr &&
	   sinCache in Repr &&
	   acosCache in Repr &&
	   sinCache != null && sinCache.Length == 180 &&
	   acosCache != null && acosCache.Length == 101
	}

    method AcosChunk0()
    modifies acosCache;
    requires acosCache != null && acosCache.Length == 101;
    {
        acosCache[0] := 900;
        acosCache[1] := 894;
        acosCache[2] := 888;
        acosCache[3] := 882;
        acosCache[4] := 877;
        acosCache[5] := 871;
        acosCache[6] := 865;
        acosCache[7] := 859;
        acosCache[8] := 854;
        acosCache[9] := 848;
    }

    method AcosChunk1()
    modifies acosCache;
    requires acosCache != null && acosCache.Length == 101;
    {
        acosCache[10] := 842;
        acosCache[11] := 836;
        acosCache[12] := 831;
        acosCache[13] := 825;
        acosCache[14] := 819;
        acosCache[15] := 813;
        acosCache[16] := 807;
        acosCache[17] := 802;
        acosCache[18] := 796;
        acosCache[19] := 790;
    }

    method AcosChunk2()
    modifies acosCache;
    requires acosCache != null && acosCache.Length == 101;
    {
        acosCache[20] := 784;
        acosCache[21] := 778;
        acosCache[22] := 772;
        acosCache[23] := 767;
        acosCache[24] := 761;
        acosCache[25] := 755;
        acosCache[26] := 749;
        acosCache[27] := 743;
        acosCache[28] := 737;
        acosCache[29] := 731;
    }

    method AcosChunk3()
    modifies acosCache;
    requires acosCache != null && acosCache.Length == 101;
    {
        acosCache[30] := 725;
        acosCache[31] := 719;
        acosCache[32] := 713;
        acosCache[33] := 707;
        acosCache[34] := 701;
        acosCache[35] := 695;
        acosCache[36] := 688;
        acosCache[37] := 682;
        acosCache[38] := 676;
        acosCache[39] := 670;
    }

    method AcosChunk4()
    modifies acosCache;
    requires acosCache != null && acosCache.Length == 101;
    {
        acosCache[40] := 664;
        acosCache[41] := 657;
        acosCache[42] := 651;
        acosCache[43] := 645;
        acosCache[44] := 638;
        acosCache[45] := 632;
        acosCache[46] := 626;
        acosCache[47] := 619;
        acosCache[48] := 613;
        acosCache[49] := 606;
    }

    method AcosChunk5()
    modifies acosCache;
    requires acosCache != null && acosCache.Length == 101;
    {
        acosCache[50] := 600;
        acosCache[51] := 593;
        acosCache[52] := 586;
        acosCache[53] := 579;
        acosCache[54] := 573;
        acosCache[55] := 566;
        acosCache[56] := 559;
        acosCache[57] := 552;
        acosCache[58] := 545;
        acosCache[59] := 538;
    }

    method AcosChunk6()
    modifies acosCache;
    requires acosCache != null && acosCache.Length == 101;
    {
        acosCache[60] := 531;
        acosCache[61] := 524;
        acosCache[62] := 516;
        acosCache[63] := 509;
        acosCache[64] := 502;
        acosCache[65] := 494;
        acosCache[66] := 487;
        acosCache[67] := 479;
        acosCache[68] := 471;
        acosCache[69] := 463;
    }

    method AcosChunk7()
    modifies acosCache;
    requires acosCache != null && acosCache.Length == 101;
    {
        acosCache[70] := 455;
        acosCache[71] := 447;
        acosCache[72] := 439;
        acosCache[73] := 431;
        acosCache[74] := 422;
        acosCache[75] := 414;
        acosCache[76] := 405;
        acosCache[77] := 396;
        acosCache[78] := 387;
        acosCache[79] := 378;
    }

    method AcosChunk8()
    modifies acosCache;
    requires acosCache != null && acosCache.Length == 101;
    {
        acosCache[80] := 368;
        acosCache[81] := 359;
        acosCache[82] := 349;
        acosCache[83] := 339;
        acosCache[84] := 328;
        acosCache[85] := 317;
        acosCache[86] := 306;
        acosCache[87] := 295;
        acosCache[88] := 283;
        acosCache[89] := 271;
    }

    method AcosChunk9()
    modifies acosCache;
    requires acosCache != null && acosCache.Length == 101;
    {
        acosCache[90] := 258;
        acosCache[91] := 244;
        acosCache[92] := 230;
        acosCache[93] := 215;
        acosCache[94] := 199;
        acosCache[95] := 181;
        acosCache[96] := 162;
        acosCache[97] := 140;
        acosCache[98] := 114;
        acosCache[99] := 81;
        acosCache[100] := 0;
    }

    method SinChunk0()
    modifies sinCache;
    requires sinCache != null && sinCache.Length == 180;
    {
        sinCache[0] := 0;
        sinCache[1] := 174;
        sinCache[2] := 348;
        sinCache[3] := 523;
        sinCache[4] := 697;
        sinCache[5] := 871;
        sinCache[6] := 1045;
        sinCache[7] := 1218;
        sinCache[8] := 1391;
        sinCache[9] := 1564;
        sinCache[10] := 1736;
        sinCache[11] := 1908;
        sinCache[12] := 2079;
        sinCache[13] := 2249;
        sinCache[14] := 2419;
        sinCache[15] := 2588;
        sinCache[16] := 2756;
        sinCache[17] := 2923;
    }

    method SinChunk1()
    modifies sinCache;
    requires sinCache != null && sinCache.Length == 180;
    {
        sinCache[18] := 3090;
        sinCache[19] := 3255;
        sinCache[20] := 3420;
        sinCache[21] := 3583;
        sinCache[22] := 3746;
        sinCache[23] := 3907;
        sinCache[24] := 4067;
        sinCache[25] := 4226;
        sinCache[26] := 4383;
        sinCache[27] := 4539;
        sinCache[28] := 4694;
        sinCache[29] := 4848;
        sinCache[30] := 4999;
        sinCache[31] := 5150;
        sinCache[32] := 5299;
        sinCache[33] := 5446;
        sinCache[34] := 5591;
        sinCache[35] := 5735;
    }

    method SinChunk2()
    modifies sinCache;
    requires sinCache != null && sinCache.Length == 180;
    {
        sinCache[36] := 5877;
        sinCache[37] := 6018;
        sinCache[38] := 6156;
        sinCache[39] := 6293;
        sinCache[40] := 6427;
        sinCache[41] := 6560;
        sinCache[42] := 6691;
        sinCache[43] := 6819;
        sinCache[44] := 6946;
        sinCache[45] := 7071;
        sinCache[46] := 7193;
        sinCache[47] := 7313;
        sinCache[48] := 7431;
        sinCache[49] := 7547;
        sinCache[50] := 7660;
        sinCache[51] := 7771;
        sinCache[52] := 7880;
        sinCache[53] := 7986;
    }

    method SinChunk3()
    modifies sinCache;
    requires sinCache != null && sinCache.Length == 180;
    {
        sinCache[54] := 8090;
        sinCache[55] := 8191;
        sinCache[56] := 8290;
        sinCache[57] := 8386;
        sinCache[58] := 8480;
        sinCache[59] := 8571;
        sinCache[60] := 8660;
        sinCache[61] := 8746;
        sinCache[62] := 8829;
        sinCache[63] := 8910;
        sinCache[64] := 8987;
        sinCache[65] := 9063;
        sinCache[66] := 9135;
        sinCache[67] := 9205;
        sinCache[68] := 9271;
        sinCache[69] := 9335;
        sinCache[70] := 9396;
        sinCache[71] := 9455;
    }

    method SinChunk4()
    modifies sinCache;
    requires sinCache != null && sinCache.Length == 180;
    {
        sinCache[72] := 9510;
        sinCache[73] := 9563;
        sinCache[74] := 9612;
        sinCache[75] := 9659;
        sinCache[76] := 9702;
        sinCache[77] := 9743;
        sinCache[78] := 9781;
        sinCache[79] := 9816;
        sinCache[80] := 9848;
        sinCache[81] := 9876;
        sinCache[82] := 9902;
        sinCache[83] := 9925;
        sinCache[84] := 9945;
        sinCache[85] := 9961;
        sinCache[86] := 9975;
        sinCache[87] := 9986;
        sinCache[88] := 9993;
        sinCache[89] := 9998;
    }

    method SinChunk5()
    modifies sinCache;
    requires sinCache != null && sinCache.Length == 180;
    {
        sinCache[90] := 10000;
        sinCache[91] := 9998;
        sinCache[92] := 9993;
        sinCache[93] := 9986;
        sinCache[94] := 9975;
        sinCache[95] := 9961;
        sinCache[96] := 9945;
        sinCache[97] := 9925;
        sinCache[98] := 9902;
        sinCache[99] := 9876;
        sinCache[100] := 9848;
        sinCache[101] := 9816;
        sinCache[102] := 9781;
        sinCache[103] := 9743;
        sinCache[104] := 9702;
        sinCache[105] := 9659;
        sinCache[106] := 9612;
        sinCache[107] := 9563;
    }

    method SinChunk6()
    modifies sinCache;
    requires sinCache != null && sinCache.Length == 180;
    {
        sinCache[108] := 9510;
        sinCache[109] := 9455;
        sinCache[110] := 9396;
        sinCache[111] := 9335;
        sinCache[112] := 9271;
        sinCache[113] := 9205;
        sinCache[114] := 9135;
        sinCache[115] := 9063;
        sinCache[116] := 8987;
        sinCache[117] := 8910;
        sinCache[118] := 8829;
        sinCache[119] := 8746;
        sinCache[120] := 8660;
        sinCache[121] := 8571;
        sinCache[122] := 8480;
        sinCache[123] := 8386;
        sinCache[124] := 8290;
        sinCache[125] := 8191;
    }

    method SinChunk7()
    modifies sinCache;
    requires sinCache != null && sinCache.Length == 180;
    {
        sinCache[126] := 8090;
        sinCache[127] := 7986;
        sinCache[128] := 7880;
        sinCache[129] := 7771;
        sinCache[130] := 7660;
        sinCache[131] := 7547;
        sinCache[132] := 7431;
        sinCache[133] := 7313;
        sinCache[134] := 7193;
        sinCache[135] := 7071;
        sinCache[136] := 6946;
        sinCache[137] := 6819;
        sinCache[138] := 6691;
        sinCache[139] := 6560;
        sinCache[140] := 6427;
        sinCache[141] := 6293;
        sinCache[142] := 6156;
        sinCache[143] := 6018;
    }

    method SinChunk8()
    modifies sinCache;
    requires sinCache != null && sinCache.Length == 180;
    {
        sinCache[144] := 5877;
        sinCache[145] := 5735;
        sinCache[146] := 5591;
        sinCache[147] := 5446;
        sinCache[148] := 5299;
        sinCache[149] := 5150;
        sinCache[150] := 4999;
        sinCache[151] := 4848;
        sinCache[152] := 4694;
        sinCache[153] := 4539;
        sinCache[154] := 4383;
        sinCache[155] := 4226;
        sinCache[156] := 4067;
        sinCache[157] := 3907;
        sinCache[158] := 3746;
        sinCache[159] := 3583;
        sinCache[160] := 3420;
        sinCache[161] := 3255;
    }

    method SinChunk9()
    modifies sinCache;
    requires sinCache != null && sinCache.Length == 180;
    {
        sinCache[162] := 3090;
        sinCache[163] := 2923;
        sinCache[164] := 2756;
        sinCache[165] := 2588;
        sinCache[166] := 2419;
        sinCache[167] := 2249;
        sinCache[168] := 2079;
        sinCache[169] := 1908;
        sinCache[170] := 1736;
        sinCache[171] := 1564;
        sinCache[172] := 1391;
        sinCache[173] := 1218;
        sinCache[174] := 1045;
        sinCache[175] := 871;
        sinCache[176] := 697;
        sinCache[177] := 523;
        sinCache[178] := 348;
        sinCache[179] := 174;
    }        
    
    method Init()
    modifies this;
    ensures IsValid() && fresh(Repr - {this});
    {
	   acosCache := new int[101];
	   AcosChunk0();
	   AcosChunk1();
	   AcosChunk2();
	   AcosChunk3();
	   AcosChunk4();
	   AcosChunk5();
	   AcosChunk6();
	   AcosChunk7();
	   AcosChunk8();
	   AcosChunk9();

       sinCache := new int[180];
       SinChunk0();
       SinChunk1();
       SinChunk2();
       SinChunk3();            
       SinChunk4();
       SinChunk5();
       SinChunk6();
       SinChunk7();
       SinChunk8();
       SinChunk9();

	   Repr := {};
	   Repr := Repr + {this} + {sinCache} + {acosCache};
    }   
        
    function method WrapAngle (angle: int) : int
    ensures if (angle > 0) then 
                  0 <= WrapAngle(angle) < 3600
             else
                  -3600 < WrapAngle(angle) <= 0;             
    {         
            if (angle < 0) then 
                -((-angle) % 3600)
            else 
                 angle % 3600
    }                 
    
    function method Cos (angle: int) : int
	reads this, sinCache;
    requires sinCache != null && sinCache.Length == 180;
    {
		Sin(angle + 900)
    }

    function method Sin (angle: int) : int
	reads this, sinCache;
    requires sinCache != null && sinCache.Length == 180;
    {
       var ap := WrapAngle(angle);       
	     var a  := if (ap < 0) then 3600 + ap else ap;                     
       var wd := a / 10;
       var tn := a - (10*wd);                          
       
       if (wd < 179) then
          var sin0 := sinCache[wd];
          var sin1 := sinCache[wd+1];
          (sin0*(10 - tn) + sin1*tn) / 10
       else if (wd == 179) then
          var sin0a := sinCache[wd];
          var sin1a := sinCache[0];       
          (sin0a*(10 - tn) + sin1a*tn) / 10
       else if (wd == 180) then
          var sin0b := sinCache[0];
          var sin1b := -sinCache[1];
          (sin0b*(10 - tn) + sin1b*tn) / 10
       else if (wd > 180 && wd < 359) then
          var sin0c := -sinCache[wd - 180];
          var sin1c := -sinCache[wd - 180 + 1];       
          (sin0c*(10 - tn) + sin1c*tn) / 10
       else 
          var sin0d := -sinCache[1];
          var sin1d := sinCache[0];        
          (sin0d*(10 - tn) + sin1d*tn) / 10
    }	     

    function method Acos (dotprod: int) : int
	reads this, acosCache;
    requires acosCache != null && acosCache.Length == 101;
    {
	   var sgn := if (dotprod < 0) then -1 else 1;
	   var mag := if (dotprod < 0) then -dotprod else dotprod;
       var base := mag / 100000000000000;
	   var rem  := (mag - 100000000000000*base) / 10000000000000; 

	   assert(mag >= 0 && ((-10000000000000000 <= dotprod <= 10000000000000000) ==> (0 <= base <= 100)));
	   assert((-10000000000000000 <= dotprod <= 10000000000000000) ==> (0 <= rem <= 10));

	   if (0 <= base <= 100) then
		  var acos0 := acosCache[base];
          var acos1 := acosCache[if (base < 100) then base + 1 else 100];
		  if (sgn < 0) then
		     1800 - ((acos0*(10 - rem) + acos1*rem) / 10)
		  else
			 (acos0*(10 - rem) + acos1*rem) / 10
	   else 
	       //// Should never reach this branch, but requires a full specification of acos to 
		   //// explain this. 
		   0
    }
				
	function method AngularDistance(p1 : CelestialPoint, p2 : CelestialPoint) : int
	reads Repr, p1.Repr, p2.Repr;
	requires p1 != null && p2 != null && p1.IsValid() && p2.IsValid() && IsValid();
	{
	     var a1 := p1.Get_Alpha().ToTenthDeg();
		 var d1 := p1.Get_Delta().ToTenthDeg();

	     var a2 := p2.Get_Alpha().ToTenthDeg();
		 var d2 := p2.Get_Delta().ToTenthDeg();

		 var cos_a1 := Cos(a1);
		 var sin_a1 := Sin(a1);

		 var cos_d1 := Cos(d1);
		 var sin_d1 := Sin(d1);

		 var cos_a2 := Cos(a2);
		 var sin_a2 := Sin(a2);

		 var cos_d2 := Cos(d2);
		 var sin_d2 := Sin(d2);

		 Acos(
		       (cos_a1 * cos_d1 * cos_a2 * cos_d2) + 
			   (sin_a1 * cos_d1 * sin_a2 * cos_d2) +
			   (10000 * sin_d1 * 10000 * sin_d2))
	}		       	  		
}




